/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

obj2map - OBJ file to Quake .map convertor

By Frank Condello
http://www.planetquake.com/paroxysm/
pox@planetquake.com
*/

// conversionmodes
#define CNVRT_DIRECT	1	// Each poly is turned into a clipping plane
#define CNVRT_FACE		2	// Each poly is converted into a pyrimidal brush
#define CNVRT_HMAP		3	// Each poly is extruded on a specified axis
#define CNVRT_EXTR		4	// Each poly is extruded along it's averaged vertex normals

#define MAX_BRUSHPLANES 2048 // Max faces for a single brush (NOTE: compiliers/editors can't really handle this many)
#define	ON_EPSILON	0.05

typedef struct
{
	vec3_t	normal;
	float	dist;
}
plane_t;

// Used by the normal extrusion algorithm
typedef struct
{
	int		idx;		// The OBJ model index number of this vertex
	int		inpolys;	// Number of polys this vert belongs to
	vec3_t	point;		// The averaged, extruded, quantized, backplane coord
	vec3_t	point2;		// The averaged, extruded, quantized, sideplane coord
}
extrvert_t;

// Keep in sync with ConTypes!!!
enum {FAC, NEX, HFC, HEW, HNS, AFC, AEW, ANS};